/*!
 * Based on chai library
 * http://chaijs.com
 * Copyright(c) 2011-2014 Jake Luer <jake@alogicalparadox.com>
 * MIT Licensed
 */

module.exports = function (_chai, util) {
  const flag = util.flag;

  class Assertion extends Promise {
    constructor(fn) {
      super(fn);

      flag(this, 'promise', this);
      flag(this, 'message', '');
    }
  }

  _chai.Assertion = Assertion;

  Assertion.addProperty = function (name, fn) {
    util.addProperty(Assertion.prototype, name, fn);
  };

  Assertion.addMethod = function (name, fn) {
    util.addMethod(Assertion.prototype, name, fn);
  };

  Assertion.addChainableMethod = function (name, fn, chainingBehavior) {
    util.addChainableMethod(Assertion.prototype, name, fn, chainingBehavior);
  };

  Assertion.overwriteProperty = function (name, fn) {
    util.overwriteProperty(Assertion.prototype, name, fn);
  };

  Assertion.overwriteMethod = function (name, fn) {
    util.overwriteMethod(Assertion.prototype, name, fn);
  };

  Assertion.overwriteChainableMethod = function (name, fn, chainingBehavior) {
    util.overwriteChainableMethod(Assertion.prototype, name, fn, chainingBehavior);
  };
};
